/* udpt.c - client for udp-Test */
#include "inet.h"
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>

int blocksize,blocknumbers;

/* read from 0, write to socket, read from socket, write to 1 */

void talk(int sockfd,struct sockaddr *pserv_addr,int servlen, int size, int number)
{
   int i,j;
   struct { int blknr;
            char sendline[65000];
          } block;

   struct { int blknr;
            int value;
          } cntblock;
   int blocki;
   float sec;
   struct timeval tv1,tv2;
   struct timezone tz1,tz2;

    cntblock.blknr=0l;
    cntblock.value=htonl(size);
   /* senden Blocklaenge */
    sendto(sockfd, &cntblock,sizeof(cntblock) ,0,pserv_addr,servlen);
    recvfrom(sockfd,&cntblock,sizeof(cntblock),0,(struct sockaddr *) 0, (socklen_t *) 0);
   /* senden Blockanzahl*/
    cntblock.blknr=0l;
    cntblock.value=htonl(number);
    sendto(sockfd, &cntblock,sizeof(cntblock) ,0,pserv_addr,servlen);
    recvfrom(sockfd,&cntblock,sizeof(cntblock),0,(struct sockaddr *) 0, (socklen_t *) 0);
    gettimeofday(&tv1,&tz1);
    for (j=0; j< 6; j++) { block.sendline[j] = 'A' ; }
    for (j=6; j< size; j++) { block.sendline[j] = random() % 256 ; }
    for ( i=1; i<=number; i++ ) {

       block.blknr=htonl(i);
      sendto(sockfd, &block,size+4,0,pserv_addr,servlen);
      recvfrom(sockfd,&blocki,4,0,(struct sockaddr *) 0, (socklen_t *) 0); 
      if (blocki != block.blknr) {
                 printf("Transportfehler Block %d\n",block.blknr);
      } 
   }
   gettimeofday(&tv2,&tz2);
   printf("Mit der Uebertragung fertig\n");
   sec=((tv2.tv_sec-tv1.tv_sec)*1000000+(tv2.tv_usec-tv1.tv_usec))/1000000.0;
   fprintf(stderr,"Duration: %f Sekunden\n",sec);
   fprintf(stderr,"KBytes/Sekunde: %f\n",((number*(size+4))/1024)/sec);
   cntblock.blknr=0l;
   cntblock.value=0;
   sleep(1);
      sendto(sockfd, &cntblock,sizeof(cntblock) ,0,pserv_addr,servlen);
}

int main(int argc,char *argv[])
{
   int sockfd;
   struct sockaddr_in serv_addr, cli_addr;
   struct hostent *hp;
   int blocksize,blocknumbers;

   if (argc != 4) {
           fprintf(stderr,"use: %s <hostname> <blocksize> <blocknumbers>\n",argv[0]);
           exit(1);
   }
   hp = gethostbyname(argv[1]);
   if (hp == NULL) {
     (void) printf("host information for %s not found\n", argv[1]);
      exit (3);
   }
   blocksize= atoi(argv[2]);
   blocknumbers= atoi(argv[3]);
   if ( blocksize >= 65000 ) {
       (void) printf("blocksize to big: %d\n",blocksize);
       exit(4);
   }
   fprintf(stderr,"Host:%s,Paketlaenge: %d, Anzahl der Pakete: %d\n",
                   argv[1],blocksize,blocknumbers);
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_port = htons(SERV_UDP_PORT);
   (void) memcpy(&serv_addr.sin_addr.s_addr, *hp->h_addr_list,
                      sizeof (serv_addr.sin_addr.s_addr));
   if ((sockfd = socket(AF_INET,SOCK_DGRAM,0)) < 0) {
      fprintf(stderr,"cu_sock: can't open stream socket\n");
      exit(-1);
   }
   bzero((char *) &cli_addr, sizeof(cli_addr));
   cli_addr.sin_family = AF_INET;
   cli_addr.sin_port = htons(0);
   cli_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   if (bind(sockfd,(struct sockaddr *) &cli_addr, sizeof(cli_addr)) < 0){
         fprintf(stderr,"cu_sock: can't bind port\n");
         exit(-2);
   }
   talk(sockfd,(struct sockaddr *) &serv_addr, sizeof(serv_addr),blocksize,blocknumbers);
   exit(0);
}
